import kivy
kivy.require('1.0.8')

from kivy.core.window import Window
from kivy.uix.widget import Widget
from kivy.uix.image import Image
from kivy.graphics import Fbo, Color, Rectangle, Ellipse
from kivy.app import App
from kivy.clock import Clock
#from kivy.graphics.instructions import Instruction
import math
import copy
import random


class CanvasForm(Widget):
    widgetCount = 0

    def __init__(self, **kwargs):
        super(CanvasForm, self).__init__(**kwargs)
        self._keyboard = Window.request_keyboard(
            self._keyboard_closed, self)
        self._keyboard.bind(on_key_down=self._on_keyboard_down)

    def getWidth(self):
        return self.size[0]

    def getHeight(self):
        return self.size[1]

    def _keyboard_closed(self):
        print('Keyboard disconnected!')
        self._keyboard.unbind(on_key_down=self._on_keyboard_down)
        self._keyboard = None


    def _on_keyboard_down(self, keyboard, keycode, text, modifiers):
        print('The key', keycode, ' pressed')
        try:
            print(' - text is ' + text)
        except:
            print(' - no text entered')
        print(' - modifiers are %r' % modifiers)
        # Keycode is composed of an integer + a string
        # If we hit escape, release the keyboard
        #if keycode[1] == 'escape':
        #    keyboard.release()
        return True

class KivyCanvasApp(App):
    def build(self):
        return CanvasForm()

if __name__ == '__main__':
    KivyCanvasApp().run()
